<!doctype html>
<html lang="en">
<head>
    <title>Code coverage report for contracts/Seller.sol</title>
    <meta charset="utf-8" />
    <link rel="stylesheet" href="../prettify.css" />
    <link rel="stylesheet" href="../base.css" />
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <style type='text/css'>
        .coverage-summary .sorter {
            background-image: url(../sort-arrow-sprite.png);
        }
    </style>
</head>
<body>
<div class='wrapper'>
  <div class='pad1'>
    <h1>
      <a href="../index.html">all files</a> / <a href="index.html">contracts/</a> Seller.sol
    </h1>
    <div class='clearfix'>
      <div class='fl pad1y space-right2'>
        <span class="strong">100% </span>
        <span class="quiet">Statements</span>
        <span class='fraction'>122/122</span>
      </div>
      <div class='fl pad1y space-right2'>
        <span class="strong">100% </span>
        <span class="quiet">Branches</span>
        <span class='fraction'>150/150</span>
      </div>
      <div class='fl pad1y space-right2'>
        <span class="strong">100% </span>
        <span class="quiet">Functions</span>
        <span class='fraction'>22/22</span>
      </div>
      <div class='fl pad1y space-right2'>
        <span class="strong">100% </span>
        <span class="quiet">Lines</span>
        <span class='fraction'>172/172</span>
      </div>
    </div>
  </div>
  <div class='status-line high'></div>
<pre><table class="coverage">
<tr><td class="line-count quiet">1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
145
146
147
148
149
150
151
152
153
154
155
156
157
158
159
160
161
162
163
164
165
166
167
168
169
170
171
172
173
174
175
176
177
178
179
180
181
182
183
184
185
186
187
188
189
190
191
192
193
194
195
196
197
198
199
200
201
202
203
204
205
206
207
208
209
210
211
212
213
214
215
216
217
218
219
220
221
222
223
224
225
226
227
228
229
230
231
232
233
234
235
236
237
238
239
240
241
242
243
244
245
246
247
248
249
250
251
252
253
254
255
256
257
258
259
260
261
262
263
264
265
266
267
268
269
270
271
272
273
274
275
276
277
278
279
280
281
282
283
284
285
286
287
288
289
290
291
292
293
294
295
296
297
298
299
300
301
302
303
304
305
306
307
308
309
310
311
312
313
314
315
316
317
318
319
320
321
322
323
324
325
326
327
328
329
330
331
332
333
334
335
336
337
338
339
340
341
342
343
344
345
346
347
348
349
350
351
352
353
354
355
356
357
358
359
360
361
362
363
364
365
366
367
368
369
370
371
372
373
374
375
376
377
378
379
380
381
382
383
384
385
386
387
388
389
390
391
392
393
394
395
396
397
398
399
400
401
402
403
404
405
406
407
408
409
410
411
412
413
414
415
416
417
418
419
420
421
422
423
424
425
426
427
428
429
430
431
432
433
434
435
436
437
438
439
440
441
442
443
444
445
446
447
448
449
450
451
452
453
454</td><td class="line-coverage quiet"><span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">35×</span>
<span class="cline-any cline-yes">29×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">20×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">17×</span>
<span class="cline-any cline-yes">17×</span>
<span class="cline-any cline-yes">16×</span>
<span class="cline-any cline-yes">15×</span>
<span class="cline-any cline-yes">15×</span>
<span class="cline-any cline-yes">14×</span>
<span class="cline-any cline-yes">13×</span>
<span class="cline-any cline-yes">12×</span>
<span class="cline-any cline-yes">11×</span>
<span class="cline-any cline-yes">10×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">9×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">6×</span>
<span class="cline-any cline-yes">5×</span>
<span class="cline-any cline-yes">5×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">5×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">6×</span>
<span class="cline-any cline-yes">5×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-yes">3×</span>
<span class="cline-any cline-yes">3×</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">5×</span>
<span class="cline-any cline-yes">5×</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-yes">3×</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-yes">3×</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-yes">3×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">5×</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-yes">3×</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">8×</span>
<span class="cline-any cline-yes">7×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">7×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">10×</span>
<span class="cline-any cline-yes">9×</span>
<span class="cline-any cline-yes">8×</span>
<span class="cline-any cline-yes">7×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">6×</span>
<span class="cline-any cline-yes">6×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">5×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">5×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">5×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">5×</span>
<span class="cline-any cline-yes">3×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">8×</span>
<span class="cline-any cline-yes">7×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">6×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">6×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">6×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">6×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">5×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">6×</span>
<span class="cline-any cline-yes">6×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">5×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">5×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">5×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">52×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">50×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">47×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">46×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">45×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">44×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">43×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">9×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">34×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">41×</span>
<span class="cline-any cline-yes">41×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">41×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">38×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">41×</span>
<span class="cline-any cline-yes">41×</span>
<span class="cline-any cline-yes">209×</span>
<span class="cline-any cline-yes">209×</span>
<span class="cline-any cline-yes">153×</span>
<span class="cline-any cline-yes">153×</span>
<span class="cline-any cline-yes">153×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">209×</span>
<span class="cline-any cline-yes">209×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">41×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">3×</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-yes">3×</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">1×</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">3×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-yes">3×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">2×</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-yes">4×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">51×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">50×</span>
<span class="cline-any cline-yes">50×</span>
<span class="cline-any cline-yes">49×</span>
<span class="cline-any cline-yes">48×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">47×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">47×</span>
<span class="cline-any cline-yes">171×</span>
<span class="cline-any cline-yes">171×</span>
<span class="cline-any cline-yes">171×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">171×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">171×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">168×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">3×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">171×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">37×</span>
<span class="cline-any cline-yes">37×</span>
<span class="cline-any cline-yes">37×</span>
<span class="cline-any cline-yes">37×</span>
<span class="cline-any cline-yes">37×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">134×</span>
<span class="cline-any cline-yes">134×</span>
<span class="cline-any cline-yes">134×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">134×</span>
<span class="cline-any cline-yes">134×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">47×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">51×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">9×</span>
<span class="cline-any cline-yes">9×</span>
<span class="cline-any cline-yes">119×</span>
<span class="cline-any cline-yes">119×</span>
<span class="cline-any cline-yes">119×</span>
<span class="cline-any cline-yes">119×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-yes">9×</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span>
<span class="cline-any cline-neutral">&nbsp;</span></td><td class="text"><pre class="prettyprint lang-js">//SPDX-License-Identifier: MIT
pragma solidity =0.8.18;
&nbsp;
import '@openzeppelin/contracts-upgradeable/token/ERC20/utils/SafeERC20Upgradeable.sol';
import '@openzeppelin/contracts-upgradeable/access/OwnableUpgradeable.sol';
&nbsp;
import './SellerUtils.sol';
&nbsp;
/**
 * @title Seller
 * @author gotbit
 * @notice Contract for receiving tokens in order to sell Node NFTs in the future.
 **/
&nbsp;
contract Seller is OwnableUpgradeable {
    using SafeERC20Upgradeable for IERC20Upgradeable;
&nbsp;
    // STATE VARIABLES
&nbsp;
    IERC20Upgradeable public token;
    SellerUtils.NodeTier[] public tiers;
    bytes32 public merkleRoot;
    string public merkleLeavesLink;
    uint256 public start;
    uint256 public end;
    address public collector;
&nbsp;
    bool public collected;
    uint256 public totalSupply;
    uint256 public nodesSupplyTotal;
    uint256 public boughtNodesTotal;
    mapping(uint256 =&gt; uint256) public boughtSupplyAtTier;
    mapping(address =&gt; mapping(uint256 =&gt; uint256)) public boughtCapByUserAtTier;
&nbsp;
    mapping(address =&gt; uint256) public boughtNodesByUser;
    address[] public users;
&nbsp;
    //  MODIFIERS
&nbsp;
    modifier beforeStart() {
        require(block.timestamp &lt; start, SellerUtils.STARTED);
        _;
    }
&nbsp;
    //  FUNCTIONS
&nbsp;
    constructor() {
        _disableInitializers();
    }
&nbsp;
    // external
&nbsp;
    receive() external payable {
        emit SellerUtils.Received(msg.sender, msg.value);
    }
&nbsp;
    /// @notice Inits a new contract
    function init(
        address _token,
        bytes32 _merkleRoot,
        string calldata _leavesLink,
        uint256 _startTimestamp,
        uint256 _endTimestamp,
        SellerUtils.NodeTier[] calldata _tiers,
        address _admin,
        address _collector
    ) external initializer {
        {
            require(_startTimestamp &gt; block.timestamp, SellerUtils.START_TOO_LOW);
            require(_endTimestamp &gt; _startTimestamp, SellerUtils.TIMESTAMPS_CROSS);
            uint256 duration = _endTimestamp - _startTimestamp;
            require(duration &gt;= SellerUtils.MIN_DURATION, SellerUtils.DURATION_TOO_LOW);
            require(duration &lt;= SellerUtils.MAX_DURATION, SellerUtils.DURATION_TOO_HIGH);
            require(_merkleRoot != bytes32(0), SellerUtils.ZERO_ROOT);
            require(bytes(_leavesLink).length != 0, SellerUtils.EMPTY_LINK);
            require(_admin != address(0), SellerUtils.ZERO_ADMIN);
            require(_collector != address(0), SellerUtils.ZERO_COLLECTOR);
&nbsp;
            SellerUtils.validateTiers(_tiers);
        }
&nbsp;
        start = _startTimestamp;
        end = _endTimestamp;
        merkleLeavesLink = _leavesLink;
        merkleRoot = _merkleRoot;
        _transferOwnership(_admin);
        collector = _collector;
        token = IERC20Upgradeable(_token); // if 0x0 =&gt; using native coin
&nbsp;
        _setTiers(_tiers);
&nbsp;
        emit SellerUtils.Init(
            _token,
            _startTimestamp,
            _endTimestamp,
            _tiers,
            _merkleRoot,
            _leavesLink,
            _collector
        );
    }
&nbsp;
    function resetTiers(
        SellerUtils.NodeTier[] calldata _tiers
    ) external onlyOwner beforeStart {
        SellerUtils.validateTiers(_tiers);
        delete tiers;
        _setTiers(_tiers);
        // event
        emit SellerUtils.ResetTiers(_tiers);
    }
&nbsp;
    function resetStart(uint256 _start) external onlyOwner beforeStart {
        require(_start &gt; block.timestamp, SellerUtils.START_TOO_LOW);
        require(_start != start, SellerUtils.DUPLICATE);
&nbsp;
        uint256 _end = end;
        require(_end &gt; _start, SellerUtils.TIMESTAMPS_CROSS);
        uint256 duration = _end - _start;
        require(duration &gt;= SellerUtils.MIN_DURATION, SellerUtils.DURATION_TOO_LOW);
        require(duration &lt;= SellerUtils.MAX_DURATION, SellerUtils.DURATION_TOO_HIGH);
&nbsp;
        start = _start;
        // event
        emit SellerUtils.ResetStart(_start);
    }
&nbsp;
    function resetEnd(uint256 _end) external onlyOwner beforeStart {
        uint256 startTimestamp = start;
        require(_end &gt; startTimestamp, SellerUtils.TIMESTAMPS_CROSS);
        uint256 duration = _end - startTimestamp;
        require(duration &gt;= SellerUtils.MIN_DURATION, SellerUtils.DURATION_TOO_LOW);
        require(duration &lt;= SellerUtils.MAX_DURATION, SellerUtils.DURATION_TOO_HIGH);
        require(_end != end, SellerUtils.DUPLICATE);
&nbsp;
        end = _end;
        // event
        emit SellerUtils.ResetEnd(_end);
    }
&nbsp;
    function resetRoot(bytes32 _root) external onlyOwner beforeStart {
        require(_root != bytes32(0), SellerUtils.ZERO_ROOT);
        require(_root != merkleRoot, SellerUtils.DUPLICATE);
        merkleRoot = _root;
        // event
        emit SellerUtils.ResetRoot(_root);
    }
&nbsp;
    function resetLeavesLink(string calldata _leavesLink) external onlyOwner {
        // can be reset during sell period due to possible storage failure (leaves link is not used for verification)
        require(bytes(_leavesLink).length != 0, SellerUtils.EMPTY_LINK);
        require(
            !SellerUtils.strCmp(_leavesLink, merkleLeavesLink),
            SellerUtils.DUPLICATE
        );
&nbsp;
        merkleLeavesLink = _leavesLink;
        // event
        emit SellerUtils.ResetLeaves(_leavesLink);
    }
&nbsp;
    function resetCollector(address _collector) external onlyOwner {
        require(block.timestamp &lt;= end, SellerUtils.OVER);
        require(_collector != address(0), SellerUtils.ZERO_ADDRESS);
        require(_collector != collector, SellerUtils.DUPLICATE);
        collector = _collector;
        // event
        emit SellerUtils.ResetCollector(_collector);
    }
&nbsp;
    function resetToken(IERC20Upgradeable _token) external onlyOwner beforeStart {
        // address 0x0 == using ETH
        require(_token != token, SellerUtils.DUPLICATE);
        token = _token;
        // event
        emit SellerUtils.ResetToken(address(_token));
    }
&nbsp;
    function collectFunds(address recepient) external {
        require(block.timestamp &gt; end, SellerUtils.NOT_OVER);
        require(msg.sender == collector, SellerUtils.NOT_COLLECTOR);
        require(!collected, SellerUtils.ALREADY_COLLECTED);
        require(recepient != address(0), SellerUtils.ZERO_ADDRESS);
&nbsp;
        uint256 supplyLocal = totalSupply;
        require(supplyLocal != 0, SellerUtils.NOTHING_TO_COLLECT);
&nbsp;
        collected = true;
&nbsp;
        // event
        emit SellerUtils.ClaimedFunds(recepient, supplyLocal);
&nbsp;
        IERC20Upgradeable tokenLocal = token;
&nbsp;
        if (address(tokenLocal) != address(0))
            tokenLocal.safeTransfer(recepient, supplyLocal);
        else SellerUtils.sendETHViaCall(payable(recepient), supplyLocal);
    }
&nbsp;
    function collectExtraFunds(address tokenToCollect, address recepient) external returns(uint256) {
        require(msg.sender == collector, SellerUtils.NOT_COLLECTOR);
        require(recepient != address(0), SellerUtils.ZERO_ADDRESS);
        // token == 0x0 =&gt; collecting ETH
&nbsp;
        uint256 lowerBoundOnContract;
&nbsp;
        if (tokenToCollect == address(token)) {
            // if funds not collected =&gt; supply stays on contract
            if (!collected) lowerBoundOnContract = totalSupply;
        } // else collect the whole balance
&nbsp;
        uint256 balance;
&nbsp;
        if (tokenToCollect == address(0)) {
            // ETH
            balance = address(this).balance;
        } else {
            // ERC20
            balance = IERC20Upgradeable(tokenToCollect).balanceOf(address(this));
        }
&nbsp;
        uint256 transferAmount = balance - lowerBoundOnContract;
        require(transferAmount != 0, SellerUtils.NOTHING_TO_COLLECT);
&nbsp;
        // event
        emit SellerUtils.ClaimedExtraFunds(recepient, tokenToCollect, transferAmount);
&nbsp;
        if (tokenToCollect == address(0)) {
            // ETH
            SellerUtils.sendETHViaCall(payable(recepient),  transferAmount);
        } else {
            // ERC20
            IERC20Upgradeable(tokenToCollect).safeTransfer(recepient,  transferAmount);
        }
&nbsp;
        return transferAmount;
    }
&nbsp;
    function purchaseNodes(
        uint256 startTier,
        uint256 nodesTargetAmount,
        bool mustFulfill,
        uint256 maxPurchaseCost,
        bytes32[] calldata merkleProof
    ) external payable {
        require(
            start &lt;= block.timestamp &amp;&amp; end &gt;= block.timestamp,
            SellerUtils.NOT_IN_PROGRESS
        );
        SellerUtils.hasAccess(msg.sender, merkleProof, merkleRoot);
&nbsp;
        (
            bool fulfilled,
            uint256[] memory buyAmountAtTier,
            uint256 totalPurchaseCost,
            uint256 nodesBought
        ) = simulatePurchaseNodes(msg.sender, startTier, nodesTargetAmount);
&nbsp;
        require(nodesBought != 0, SellerUtils.ZERO_NODES_BOUGHT);
&nbsp;
        // revert if fulfilled required but not possible
        if (mustFulfill) require(fulfilled, SellerUtils.NOT_FULFILLED);
&nbsp;
        if (maxPurchaseCost != 0) {
            // check totalPurchaseCost
            require(totalPurchaseCost &lt;= maxPurchaseCost, SellerUtils.MAX_PRICE_EXCEEDED);
        }
&nbsp;
        if (address(token) == address(0)) {
            // native coin
            require(msg.value == totalPurchaseCost, SellerUtils.WRONG_COST);
        } else {
            // ERC20 token
            token.safeTransferFrom(msg.sender, address(this), totalPurchaseCost);
        }
&nbsp;
        // change the state variables
&nbsp;
        totalSupply += totalPurchaseCost;
        boughtNodesTotal += nodesBought;
&nbsp;
        if (boughtNodesByUser[msg.sender] == 0) {
            // first invest
            users.push(msg.sender);
        }
&nbsp;
        uint256 len = tiers.length;
        for (uint256 tierId = startTier; tierId &lt; len; ) {
            uint256 buyAmount = buyAmountAtTier[tierId];
            if (buyAmount != 0) {
                boughtCapByUserAtTier[msg.sender][tierId] += buyAmount;
                boughtSupplyAtTier[tierId] += buyAmount;
                boughtNodesByUser[msg.sender] += buyAmount;
            }
&nbsp;
            unchecked {
                ++tierId;
            }
        }
&nbsp;
        emit SellerUtils.PurchasedNodes(msg.sender, nodesBought, totalPurchaseCost);
    }
&nbsp;
    // external view
&nbsp;
    function checkAvailableSupplyPerTier(
        uint256 tierIndex
    ) external view returns (uint256) {
        require(tierIndex &lt; tiers.length, SellerUtils.WRONG_INDEX);
        SellerUtils.NodeTier memory tier = tiers[tierIndex];
        return tier.supply - boughtSupplyAtTier[tierIndex];
    }
&nbsp;
    function checkAvailableCapPerAddressAtTier(
        address user,
        uint256 tierIndex
    ) external view returns (uint256) {
        require(user != address(0), SellerUtils.ZERO_ADDRESS);
        require(tierIndex &lt; tiers.length, SellerUtils.WRONG_INDEX);
        SellerUtils.NodeTier memory tier = tiers[tierIndex];
        return tier.capacityPerAddress - boughtCapByUserAtTier[user][tierIndex];
    }
&nbsp;
    function getUserInfoSlice(
        uint256 offset,
        uint256 limit
    ) external view returns (SellerUtils.UserInfo[] memory res) {
        uint256 len = users.length;
        res = new SellerUtils.UserInfo[](len);
        require(offset + limit &lt;= len, SellerUtils.INVALID_SLICE);
        require(limit != 0, SellerUtils.ZERO_LENGTH);
&nbsp;
        for (uint256 i; i &lt; limit; ) {
            address user = users[i + offset];
            res[i] = SellerUtils.UserInfo({
                user: user,
                nodesAmount: boughtNodesByUser[user]
            });
            unchecked {
                ++i;
            }
        }
    }
&nbsp;
    function getUsersLength() external view returns (uint256) {
        return users.length;
    }
&nbsp;
    function getTiersLength() external view returns (uint256) {
        return tiers.length;
    }
&nbsp;
    function getTiersSlice(
        uint256 offset,
        uint256 limit
    ) external view returns (SellerUtils.NodeTier[] memory res) {
        uint256 len = tiers.length;
        res = new SellerUtils.NodeTier[](len);
        require(offset + limit &lt;= len, SellerUtils.INVALID_SLICE);
        require(limit != 0, SellerUtils.ZERO_LENGTH);
&nbsp;
        for (uint256 i; i &lt; limit; ) {
            res[i] = tiers[i + offset];
            unchecked {
                ++i;
            }
        }
    }
&nbsp;
    // public
&nbsp;
    function simulatePurchaseNodes(
        address user,
        uint256 startTier,
        uint256 nodesTargetAmount
    )
        public
        view
        returns (
            bool fulfilled,
            uint256[] memory buyAmountAtTier,
            uint256 totalPurchaseCost,
            uint256 totalBought
        )
    {
        require(
            checkAvailableSupplyTotal() &gt;= nodesTargetAmount,
            SellerUtils.NODES_TOTAL_EXCEEDED
        );
        uint256 len = tiers.length;
        require(startTier &lt; len, SellerUtils.WRONG_INDEX);
        require(user != address(0), SellerUtils.ZERO_ADDRESS);
        require(nodesTargetAmount != 0, SellerUtils.ZERO_AMOUNT);
&nbsp;
        buyAmountAtTier = new uint256[](len); // [0, 0, ..., 0] - tiers.length
&nbsp;
        for (uint256 tierId = startTier; tierId &lt; len; ) {
            SellerUtils.NodeTier memory tier = tiers[tierId];
            uint256 availableSupplyAtTier = tier.supply - boughtSupplyAtTier[tierId];
            uint256 availableCapForUserAtTier = tier.capacityPerAddress -
                boughtCapByUserAtTier[user][tierId];
&nbsp;
            uint256 buyAtThisTier;
&nbsp;
            if (availableCapForUserAtTier &lt;= availableSupplyAtTier) {
                // can stop at the current tier
                buyAtThisTier = availableCapForUserAtTier;
            } else {
                // must buy the rest of the supply, reduce cap and move to the next tier
                buyAtThisTier = availableSupplyAtTier;
            }
&nbsp;
            if (totalBought + buyAtThisTier &gt; nodesTargetAmount) {
                // must reduce the buy amount and stop purchase (will work only once)
                buyAtThisTier = nodesTargetAmount - totalBought;
                totalPurchaseCost += tier.pricePerNode * buyAtThisTier;
                buyAmountAtTier[tierId] = buyAtThisTier;
                totalBought += buyAtThisTier;
                break;
            }
&nbsp;
            // can buy the whole amount
            totalPurchaseCost += tier.pricePerNode * buyAtThisTier;
            buyAmountAtTier[tierId] = buyAtThisTier;
            totalBought += buyAtThisTier;
&nbsp;
            unchecked {
                ++tierId;
            }
        }
&nbsp;
        // check if bought the whole targer amount
&nbsp;
        // totalBought &lt;= nodesTargetAmount due to function logic
        fulfilled = (totalBought == nodesTargetAmount);
    }
&nbsp;
    function checkAvailableSupplyTotal() public view returns (uint256) {
        return nodesSupplyTotal - boughtNodesTotal;
    }
&nbsp;
    function _setTiers(SellerUtils.NodeTier[] memory _tiers) private {
        uint256 supplyAllNodes;
        for (uint256 i; i &lt; _tiers.length; ) {
            tiers.push(_tiers[i]);
            supplyAllNodes += _tiers[i].supply;
            unchecked {
                ++i;
            }
        }
        nodesSupplyTotal = supplyAllNodes;
    }
}
&nbsp;</pre></td></tr>
</table></pre>
<div class='push'></div><!-- for sticky footer -->
</div><!-- /wrapper -->
<div class='footer quiet pad2 space-top1 center small'>
  Code coverage
  generated by <a href="http://istanbul-js.org/" target="_blank">istanbul</a> at Thu Jun 27 2024 19:04:27 GMT+0300 (Moscow Standard Time)
</div>
</div>
<script src="../prettify.js"></script>
<script>
window.onload = function () {
        if (typeof prettyPrint === 'function') {
            prettyPrint();
        }
};
</script>
<script src="../sorter.js"></script>
</body>
</html>
